//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	AbstractBasicSkills.h
 *  \brief Definicia CAbstractBasicSkills
 *  \author Rado Kostelnik
 *  \date 1.12.2001 13:12:08
 *  \version 0.0

 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
#ifndef ABSTRACTBASICSKILLS_H
#define ABSTRACTBASICSKILLS_H

#include "skillscommon.h"

#define BSKILL_KICK			100   
	#define BSKILL_KICK_WITH_POWER 101 //smer - double, sila kopu - double 
	#define BSKILL_KICK_WITH_ACCEL 102  //smer - double, akceleracia(zrychlenie) - double 
	#define BSKILL_KICK_WITH_ACCEL_BYPASS 103 // pozicia -  C2DVector, akceleracia(zrychlenie) - double //taky kop aby som netrafil hraca v smere kopu
	#define BSKILL_KICK_TO_POSITION 104 //  pozicia - C2DVector, akceleracia(zrychlenie) -double
	#define BSKILL_KICK_GOAL 105		//bez parametra
	#define BSKILL_KICK_FRIENDKICK 106  //bez parametra, to ktoremu spoluhracovi ma nahrat, si vypocita sam
										 

#define BSKILL_MOVE  200
	#define BSKILL_MOVE_DASH 201     //power - double// elementarny pohyb vpred
	#define BSKILL_MOVE_GOTO 202	 //pozicia - C2DVector , zrychlenie - double 
	#define BSKILL_MOVE_FACETOGO 203 //pohybujuci sa objekt - CMovingObject *, pozicia(kam sa ma hrac dostat) - C2DVector, zrychlenie -double//beh na urcenu poziciu, pricom sa pozeram, stale na urcity objekt 
	#define BSKILL_MOVE_TO 204		 //pozicia - C2DVector alebo suradnice x,y //hrac sa nastvy na urcenu, poziciu 

#define BSKILL_TURN				300 
	#define BSKILL_TURN_ME		301 //moment - double
	#define BSKILL_TURN_NECK	302 //moment - double
	#define BSKILL_TURN_TO		303 //pozicia - C2DVector
	#define BSKILL_TURN_NECK_TO	304 //pozicia - C2DVector
	#define BSKILL_TURN_TO_BALL	305 //bez parametrov//otocenie sa za loptou
	#define BSKILL_TURN_NECK_STRAIGHT	306 //bez parametrov//otocenie hlavy dopradu
	#define BSKILL_TURN_2		307    //uhol otocenia - double 


#define BSKILL_CATCH	400
	#define BSKILL_CATCH0 401	//direction(smer) - double

//este nie je hotove
#define BSKILL_DRIBBLE	500
	#define BSKILL_DRIBLE_SMART 501 //pozicia - C2DVector, zrychlenie - double


class CLocalAgent
{

};

class CEstimateLocalSituation
{
};


class CAbstractBasicSkills  
{
private:
	int m_skillType, m_priority;
	CLocalAgent *m_agent;
	
public:
	CEstimateLocalSituation	*m_localSituation;
	
	CAbstractBasicSkills() {};
	CAbstractBasicSkills(int skillType, int priority, CLocalAgent *player) {}; 
	CAbstractBasicSkills(const CAbstractBasicSkills &skill) {};
	
	virtual ~CAbstractBasicSkills() {};

	virtual void Execute() {};

	void SetSkillType( int type ) {  m_skillType = type; };
	int GetSkillType() {  return m_skillType; }
	int GetPriority() { return m_priority; }
	
	void SetAgent( CLocalAgent *agent  ) {  m_agent = agent; }; 
	CLocalAgent *GetAgent() { return m_agent; };
	

	operator=(CAbstractBasicSkills &skill); 

protected:
	double m_accel, m_power, m_dir, m_moment;
	C2DVector m_pos;
	int m_skillSkillType;
};

bool operator<(CAbstractBasicSkills  &lhs, CAbstractBasicSkills &rhs);

class CKick: public CAbstractBasicSkills
{
private:
//	int	   m_kickType;

public:
	CKick( int kickType, double accel, double dir, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_KICK, priority, pl ) 
	{
	};

	CKick( int kickType, double accel, C2DVector pos, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_KICK, priority, pl ) 
	{
	};
	void Execute() {};
};

class CMove: public CAbstractBasicSkills
{
private:
	double m_dir,m_x, m_y;
	
public:
	CMove( int moveType, double accel, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_MOVE, priority, pl ) 
	{
	};
	CMove( int moveType, C2DVector pos, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_MOVE, priority, pl ) 
	{
	};
	void Execute() {};
};

class CTurn: public CAbstractBasicSkills
{
private:
	double m_moment;
public:
	CTurn( int turnType, double moment, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_MOVE, priority, pl ) 
	{
		
	};
	CTurn( int turnType, C2DVector pos, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_MOVE, priority, pl ) 
	{
	};

	void Execute() {};
};

class CCatch: public CAbstractBasicSkills
{	
public:
	CCatch( int catchType, double dir, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_MOVE, priority, pl ) 
	{
		m_skillSkillType = catchType;
		m_dir = dir;
	};
	void Execute() {};
};

class CDribble: public CAbstractBasicSkills 
{
private:
	C2DVector m_lastPos;
public:
	CDribble(int dribleType, double dir, CLocalAgent *pl, int priority  ) {};
	CDribble(int dribleType, C2DVector destPos, CLocalAgent *pl, int priority  ) {};
	void Execute() {};
};


class CAbstractBasicSkillsList 
{
private:
	list<CAbstractBasicSkills> m_skillsList;

public:
	void AddSkill( CAbstractBasicSkills &skills) { m_skillsList.push_back( skills ); }
	bool IsEmpty() { return m_skillsList.empty(); };
	void Empty() { m_skillsList.clear(); };
	void Sort() { m_skillsList.sort() ;}
	void RemoveSkill() {};
	virtual void EvaluateAndRemove() {};

};


#endif //ABSTRACTBASICSKILLS_H