//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	HigherSkills.cpp
 *  \brief Implementacia HigherSkills - vyssie schopnosti hraca
 *  \author Rado Kostelnik
 *  \date 1.12.2001 17:28:47
 *  \version 0.1

 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "skillscommon.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CHigherSkills::CHigherSkills()
{
	m_ruleengine.loadXML( "j:\\timovy\\source\\rules.xml" );
}

CHigherSkills::~CHigherSkills()
{

}

//------------------------------------------------------
/*! \fn	void CHigherSkills::deliberate( CLocalAgent* p )
 *  \brief Rozhodovanie o nasledujucej cinnosti na vyssej urovni
 *  \param CLocalAgent* p agent, ktoremu urcujeme cinnosti
 *  \return nic
 *  \author Rado Kostelnik
 *  \date 1.12.2001 17:16:09

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
void CHigherSkills::deliberate( CLocalAgent* p )
{
	TActionVector* av;
	CAbstractBasicSkillsList sl;  
	CAbstractBasicSkills* s = NULL;

	CQuery q;

	av = m_ruleengine.Evaluate( "default", q );

	if (av)
	{
		TActionVectorIterator ai = av->begin();
		TActionVectorIterator ae = av->end();

		for ( ; ai != ae; ai++ )
		{
			CAction& a = *ai;

			//
			// Kick
			//
			if ( a.name == "Kick" )
			{
				TParameterVectorIterator pi = a.parameters().begin();
				TParameterVectorIterator pe = a.parameters().end();
				CParameter& p = *pi;

				if ( p.name == "Location" && p.value == "Goal" )
					s = new CKick( BSKILL_KICK_GOAL, 0, 0, p, 0 );
				else 
					s = new CKick( BSKILL_KICK, 0, 0, p, 0 );
			}
			else 
			//
			// GoToPosition
			//
			if ( a.name == "GoToPosition" )
			{
				s = new CMove( BSKILL_MOVE, 0, p, 0 ); 
			}
			else 
			//
			// DribbleTo
			//
			if ( a.name == "DribbleTo" )
			{
				s = new CDribble( BSKILL_DRIBBLE, 0, p, 0 ); 
			}
			else 
			//
			// TurnTo
			//
			if ( a.name == "TurnTo" )
			{
				s = new CTurn( BSKILL_TURN, 0, p, 0 ); 
			}
			else
			//
			// PassTo
			//
			if ( a.name == "PassTo" )
			{
				s = new CKick( BSKILL_KICK_FRIENDKICK, 0, 0, p, 0 ); 
			}
			else 
			//
			// Catch
			//
			if ( a.name == "Catch" )
			{
				s = new CCatch( BSKILL_CATCH, 0, p, 0 ); 
			}

			if ( s )
				sl.AddSkill( *s );
				
			s = NULL;
		
		}
	}
}