<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

	<xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes" indent="yes"/>
	<xsl:decimal-format NaN=""/>
	
<xsl:template match="/">
	<html>
		<meta http-equiv="content-type" content="text/html; charset=windows-1250"/>
		<head>
			<link rel="stylesheet" type="text/css" href="default.css"></link>
		</head>
	
		<body>
			<xsl:apply-templates select="rules" />	
		</body>
	</html>
</xsl:template>

<xsl:template match="rules">
	<div class="bc1 bold" style="font-size: 14pt;">Rules</div>
	
	<table style="width: 100%; table-layout: fixed; border-collapse: collapse;">
		<col style="width: 20em;"/>
		<col/>
		<col/>

		<thead>
			<th class="bc7">Name</th>
			<th class="bc7">Conditions</th>
			<th class="bc7">Actions &amp; Parameters</th>
		</thead>
		
		<xsl:apply-templates select="rule" />	
	</table>
</xsl:template>
	
<xsl:template match="rule">
	<tr>
		<td class="bc4 bold border1 borderc6"><xsl:value-of select="@name"/></td>
		<td class="border1 borderc6">
			<xsl:apply-templates select="conds" />
		</td>
		<td class="border1 borderc6">
			<xsl:apply-templates select="actions" />
		</td>
	</tr>
</xsl:template>	

<xsl:template match="conds">
	<table style="width: 100%; border-collapse: collapse;" cellspacing="0">
		<xsl:apply-templates select="cond" />	
	</table>
</xsl:template>

<xsl:template match="cond">
	<tr>
		<td class="bc5"><xsl:value-of select="@variable"/><xsl:value-of select="@operator"/><xsl:value-of select="@value"/></td>
	</tr>
</xsl:template>	

<xsl:template match="actions">
	<table style="width: 100%; border-collapse: collapse;"  cellspacing="0">
		<xsl:apply-templates select="action" />	
	</table>
</xsl:template>

<xsl:template match="action">
	<tr>
		<xsl:variable name="tmp">
			<xsl:choose>
				<xsl:when test="/rules/rule[current()/@name = @name]"></xsl:when>
				<xsl:otherwise>bc1</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		
		<xsl:element name="td">
			<xsl:attribute name="class"><xsl:value-of select="$tmp"/></xsl:attribute>
			<xsl:value-of select="@name"/>
		
			<xsl:if test="parameters/parameter">
				<span>(
					<xsl:for-each select="parameters/parameter">
						<xsl:value-of select="@name"/>=<xsl:value-of select="@value"/><xsl:if test="position() != last()">,</xsl:if>
					</xsl:for-each>
				)</span>
			</xsl:if>
		</xsl:element>
	</tr>
</xsl:template>	
	
</xsl:stylesheet>
